/*-
 * ~~~~~~licensing~~~~~~
 * artifact-management
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.artifact.installer.builder.typed;

import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;
import java.util.HashMap;
import java.util.Map;

import ru.entaxy.platform.core.artifact.Artifact;
import ru.entaxy.platform.core.artifact.installer.builder.typed.impl.BlueprintInstallerImpl;
import ru.entaxy.platform.core.artifact.installer.builder.typed.impl.BundleInstallerImpl;
import ru.entaxy.platform.core.artifact.installer.builder.typed.impl.JarInstallerImpl;
import ru.entaxy.platform.core.artifact.installer.builder.typed.impl.TypedInstallerImpl;

@TypedInstallerFactoryDescriptor(supportedTypes = {Artifact.ARTIFACT_CATEGORY_BLUEPRINT,
    Artifact.ARTIFACT_CATEGORY_BUNDLE, Artifact.ARTIFACT_CATEGORY_JAR},
        supportedClasses = {BlueprintInstaller.class, BundleInstaller.class, JarInstaller.class})
public class DefaultTypedInstallerFactory extends AbstractTypedInstallerFactory {

    protected static DefaultTypedInstallerFactory INSTANCE;

    public static DefaultTypedInstallerFactory getInstance() {
        if (INSTANCE == null)
            INSTANCE = new DefaultTypedInstallerFactory();
        return INSTANCE;
    }

    protected static Map<String, Class<? extends TypedInstallerImpl>> typeToClassMap;
    protected static Map<Class<? extends TypedInstaller>, Class<? extends TypedInstallerImpl>> classToClassMap;

    static {

        typeToClassMap = new HashMap<>();
        typeToClassMap.put(Artifact.ARTIFACT_CATEGORY_BLUEPRINT, BlueprintInstallerImpl.class);
        typeToClassMap.put(Artifact.ARTIFACT_CATEGORY_BUNDLE, BundleInstallerImpl.class);
        typeToClassMap.put(Artifact.ARTIFACT_CATEGORY_JAR, JarInstallerImpl.class);

        classToClassMap = new HashMap<>();
        classToClassMap.put(BlueprintInstaller.class, BlueprintInstallerImpl.class);
        classToClassMap.put(BundleInstaller.class, BundleInstallerImpl.class);
        classToClassMap.put(JarInstaller.class, JarInstallerImpl.class);

    }

    protected DefaultTypedInstallerFactory() {
        super();
    }

    @Override
    protected TypedInstaller doCreate(String type) {
        Class<? extends TypedInstallerImpl> clazz = typeToClassMap.get(type);
        if (clazz == null)
            return null;
        return createOfClass(clazz);
    }

    @Override
    protected TypedInstaller doCreate(Class<? extends TypedInstaller> targetClass) {
        Class<? extends TypedInstallerImpl> clazz = classToClassMap.get(targetClass);
        if (clazz == null)
            return null;
        return createOfClass(clazz);
    }

    protected TypedInstaller createOfClass(Class<? extends TypedInstallerImpl> clazz) {
        try {
            Constructor<?> constructor = clazz.getConstructor();
            return (TypedInstaller) constructor.newInstance();
        } catch (NoSuchMethodException | SecurityException | InstantiationException | IllegalAccessException
                | IllegalArgumentException | InvocationTargetException e) {
            return null;
        }
    }
}
